
x = -0.1:0.001:1.1;
y = x;

resol = size(x,2);
x1 = repmat(x,resol,1);
y1 = repmat(y,resol,1);

prod1 = x1 .* y1';
prod2 = zeros(resol);

RCThreshold = 1.025;
RDThreshold = -0.073;

percentRC = sum(size(find(prod1 > RCThreshold),1)) / (resol^2) * 100;
percentRD = sum(size(find(prod1 < RDThreshold),1)) / (resol^2) * 100;

disp(['Percentage RC: ' num2str(percentRC) 'Percentage RD: ' num2str(percentRD)]);

figure1 = figure('XVisual',...
    '0x22 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');

axes1 = axes('Parent',figure1);
mesh(prod1,'Parent',axes1);

view(axes1,[90 -90]);
axis image;


for i = 1:resol
    for j = 1:resol
        if prod1(i,j) > RCThreshold;
            prod2(i,j) = 0.5;
        end
        if prod1(i,j) < RDThreshold
            prod2(i,j) = -1;
        end
    end
end

prod2(resol,resol) = 0.51;
prod2(resol,1) = - 1.01;
prod2(1,resol) = - 1.01;


figure2 = figure('XVisual',...
    '0x22 (TrueColor, depth 24, RGB mask 0xff0000 0xff00 0x00ff)');

axes2 = axes('Parent',figure2);
mesh(prod2,'Parent',axes2);

axis image;
view(axes2,[90 -90]);
