function [etrace, totmodul, w] = integrationTest(tottime, p_samplingTime,p_modTC, p_plot)

p_traceTC = 1;
p_baseMod = 0.0;

steps = round(tottime/p_samplingTime);
timeVector = 0:p_samplingTime:tottime;

modul = zeros(1,steps);
modulInput = zeros(1,steps);
w = zeros(1,steps);


timeStepsAtSec = round((1:5)/p_samplingTime);

traceShape = 1;

% exponential decay
if traceShape == 1
    etrace = 0.5*exp(-timeVector/p_traceTC);
end

% explonention decay with reversal at sec 3
if traceShape == 2
    etrace = exp(-timeVector/p_traceTC);
    etrace(timeStepsAtSec(3)+1:timeStepsAtSec(5)+1) = -exp(-timeVector(1:timeStepsAtSec(2)+1)/p_traceTC);
end

% tanh decay with reversal at sec 3
if traceShape == 3
    etrace = max(tanh(3*(2.5-timeVector)/p_traceTC),0);
    etrace(timeStepsAtSec(3)+1:timeStepsAtSec(5)+1) = min( -tanh(3*(2-timeVector(1:timeStepsAtSec(2)+1))/p_traceTC) ,0);
end

%modulInput(1) = 1;
modulInput(round(2/p_samplingTime) + 1) = 1;

for i = 2:steps
        
    modul(i)  = modul(i-1)  .* exp(-p_samplingTime/p_modTC) + modulInput(i-1);
    % modulation scaled according to decay (i.e. less but for longer == equal quantity)
    totmodul(i) = (modul(i) + p_baseMod) / p_modTC;
    % reward not scaled (i.e. longer reuptake)
    %totmodul(i) = (modul(i) + p_baseMod) / 0.2;

    if p_modTC == 0
        w(i) = w(i-1) + etrace(i) * totmodul(i);        
    else
        w(i) = w(i-1) + etrace(i) * totmodul(i) * p_samplingTime;
    end
end

if p_plot == 1
    subplot(3,1,1);
    plot(etrace)
    grid
    subplot(3,1,2)
    plot(totmodul);
    grid
    subplot(3,1,3)
    plot(w);
    grid
end

end