% Monitor the number of correlations over a one second time window 

if s_remainingStepsInEstimation == 0
    % start a 1-second estimation
    s_remainingStepsInEstimation = round(1/p_samplingTime);
    s_correlationsOverOneSecond = zeros(round(1/p_samplingTime), t_numberOfPlasticSynapses);
    t_count = 1;
else
    % store a one-step correlations in one vector (reshape a matrix)
    s_correlationsOverOneSecond(t_count,:) = reshape(nonzeros(s_correlations),1,t_numberOfPlasticSynapses);
    t_count = t_count + 1;
    s_remainingStepsInEstimation = s_remainingStepsInEstimation - 1;
    
    % if it's the last sample in the 1-second estimation...
    if s_remainingStepsInEstimation == 0;
        % Put all correlations over one second in one single vector and sort it
        s_allSortedCorrelations = sort(reshape(s_correlationsOverOneSecond,1,t_nrOfCorrelationsPerSecond));
        
        s_posThresholdLocation = round(size(s_allSortedCorrelations,2) - (t_numberOfPlasticSynapses * p_HCPerSecond));
        s_negThresholdLocation = round(t_numberOfPlasticSynapses * p_HCPerSecond);
        
        % Updating the vector of thresholds.
        
        %Shifting
        s_positiveCorrThresholdSample(2:size(s_positiveCorrThresholdSample,2)) =...
            s_positiveCorrThresholdSample(1:size(s_positiveCorrThresholdSample,2)-1);
        s_negativeCorrThresholdSample(2:size(s_negativeCorrThresholdSample,2)) =...
            s_negativeCorrThresholdSample(1:size(s_negativeCorrThresholdSample,2)-1);
        
        %Inserting the last-found value
        s_positiveCorrThresholdSample(1) = s_allSortedCorrelations(s_posThresholdLocation);
        s_negativeCorrThresholdSample(1) = s_allSortedCorrelations(s_negThresholdLocation);
        
        %Computing the new average
        p_positiveCorrThreshold = mean(nonzeros(s_positiveCorrThresholdSample));
        p_negativeCorrThreshold = mean(nonzeros(s_negativeCorrThresholdSample));
    end
end


