tic;
s_oldOutput = s_output;

if p_modulationContributesToActivity == 1
    s_stimuliInput(:) = p_modulationContributesToActivityFactor * s_totalModulation;
end

if p_elig == 0
    s_neuronInput = s_stimuliInput' + s_oldOutput' * (s_weightSum .* s_connectionTypeStrength);
else
    s_neuronInput = s_stimuliInput' + s_oldOutput' * (s_weightM .* s_connectionTypeStrength);
end

if p_modulationContributesToActivity == 2
    if s_modulation == p_maxModulation
        s_activationFactor = p_activationFactor * 2; 
    else
        s_activationFactor = p_activationFactor;
    end
end

% computing new outputs and adding noise
s_output =  max(tanh(s_activationFactor .* s_neuronInput),0.0)' + mysymrand(stream, p_nr_neurons, 1, p_transmissionNoise);

s_correlations = sparse(s_plasticityM .* (s_oldOutput * s_output'));

% resetting high correlationa from previous time step
s_highCorr = sparse(p_nr_neurons,p_nr_neurons);

% finding positive correlating weights
s_highCorr(s_correlations > p_positiveCorrThreshold) = p_traceIncrementWithPC;
s_numberOfPosHighCorrPerStep = nnz(s_highCorr);

% finding negative correlating weights
s_highCorr(s_correlations < p_negativeCorrThreshold) = p_traceDecrementWithNC;
s_numberOfNegHighCorrPerStep = nnz(s_highCorr == -1);

s_cputime(1) = s_cputime(1) + toc;
