% Andrea Soltoggio (C) 2011-2012
% Software provided as support material for the paper:
% Solving the Distal Reward Problem with Rare Correlations
% Neural Computation Journal 
% 2012

if exist('t_executingSet','var') == 0
    clear;
    t_executingSet = 0;

    disp('Growth of single synapse');
    p_simTime                       = 5400;
    p_traceTC                       = 2;
    p_minTimeToReward               = 1;
    p_maxTimeToReward               = 3;
    p_samplingTime                  = 0.5;
    p_HCPerSecond                   = 0.01;
    p_minIntervalBetweenRewards     = 2 * p_maxTimeToReward;
        
    addpath exp1;
    addpath common;

    p_seedNumber = 1;
   % stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);

    userChoicesE1;
   
else
    disp('Run within statistical set');
end

t_expNr                 = 1;

init;

% pick one random A neuron, repeat to change the precise neuron chosen.
s_neuronA       = myrandi(stream,1,1,1,p_nr_excitatory);

% pick one random B neuron that is connected with A
while 1==1
    s_neuronB       = myrandi(stream,1,1,1,p_nr_excitatory);
    if (s_connectivity(s_neuronA, s_neuronB) == 1)...
        && (s_connectivity(s_neuronB, s_neuronA) ==0)                                 % this ensures that the neurons A and B are connected
        break;
    end
end

s_weightM(s_neuronA,s_neuronB) = 0;


%s_connectivity(s_neuronB,:) = 0;

% Derived parameters, logs and control variables -------------------------%
s_minStepsToReward          = round(p_minTimeToReward / p_samplingTime );
s_maxStepsToReward          = round(p_maxTimeToReward / p_samplingTime );
s_step                      = t_startAtStep;
s_highCorr                  = sparse(p_nr_neurons,p_nr_neurons);
s_stimulusAtStep            = 0;


l_oneWeight             = zeros(1, s_totSteps);
l_oneWeightS            = zeros(1, s_totSteps);
l_ExW                   = zeros(1, s_totSteps);
l_InW                   = zeros(1, s_totSteps);
l_oneWeightCorr         = zeros(1, s_totSteps);
l_eligTrace             = zeros(1, s_totSteps);
l_corrValues            = zeros(1, s_totSteps);
l_output                = zeros(1,s_totSteps);
l_bins                  = zeros(s_totSteps,101);
l_inducedCorr           = zeros(1,s_totSteps);

t_showOnceMore          = 0;

%Plasticty
s_plasticityM                   = s_connectivity;
s_plasticityM(p_nr_excitatory + 1:p_nr_neurons,:)       = 0;
t_numberOfSynapses              = nnz(s_connectivity);
t_numberOfPlasticSynapses       = nnz(s_plasticityM);
t_nrOfCorrelationsPerSecond     = sum(nnz(s_plasticityM))*t_stepsPerSecond;


% Launching --------------------------------------------------------------%
    
    displayGraphsE1;
    
    runE1;

% Plotting results -------------------------------------------------------%
disp(['Reward episodes ' num2str(size(find(l_modulation == p_maxModulation),2))]);

if t_suspendExecutionVar == 0
    if t_executingSet == 1
        s_currentSeed = s_seedn;
    else
        s_currentSeed = p_seedNumber;
    end
    filename = ['e1r'  num2str(p_revision)...
        'seed' num2str(s_currentSeed)...
        'int' num2str(p_samplingTime*1000) 'ms'...
        'time' num2str(s_time)...
        'trace' num2str(p_traceTC)...
        'LTt' num2str(p_decayLT) 's'...
        'maxDelay' num2str(p_maxTimeToReward)...
        'rc' num2str(p_HCPerSecond)...
        'noise' num2str(p_transmissionNoise) '.mat'];
    save(filename);
    displayGraphsE1;
    refreshGraphsE1;
    s_cputime
else
    save matlabTempE1;
end
