if exist('executingSet','var') == 0
    clear;
    disp('Classical Conditioning');
    
    p_simTime                = 7200;
    p_samplingTime           = 0.025; 
end

p_traceTC                = 1;

p_minTimeToReward        = 0;
p_maxTimeToReward        = 1;
p_minTimeBetweenStimuli  = 0.1;
p_maxTimeBetweenStimuli  = 0.3;
p_stimuliStrength        = 20;
p_HCPerSecond            = 0.01;
p_nr_sets                = 100;   

p_sampleThresholdEstimationInSec            = 10;
p_monitoringSlindingWindowLengthInSeconds   = 1;


addpath exp2;
addpath common; 

userChoicesE2;

init;

s_stimuliSet             = myrandi(stream, p_nr_sets, 50, 1, p_nr_excitatory);

% Derived parameters, logs and control variables -------------------------%
s_stepsToStimulus        = 1;

s_minStepsToStimulus     = round(p_minTimeBetweenStimuli / p_samplingTime);
s_maxStepsToStimulus     = round(p_maxTimeBetweenStimuli / p_samplingTime);

s_minStepsToReward      = round(p_minTimeToReward / p_samplingTime);
s_maxStepsToReward      = round(p_maxTimeToReward / p_samplingTime);


l_CSsynapses            = zeros(1,s_totSteps);
l_allSynapses           = zeros(1,s_totSteps);
l_meanEW                = zeros(1,s_totSteps);
l_meanIW                = zeros(1,s_totSteps);
l_output                = zeros(1,s_totSteps);
l_stimuli               = zeros(1,s_totSteps);
l_stimulus1             = zeros(1,s_totSteps);

t_currentStimulus       = 0;
t_showOnceMore          = 0;

t_expNr                 = 2; 
t_visual                = 0;

%Plasticity (this must be done after specific experiment settings)
s_plasticityM           = s_connectivity;
s_plasticityM(p_nr_excitatory + 1:p_nr_neurons,:) = 0;
t_numberOfSynapses      = nnz(s_connectivity);
t_numberOfPlasticSynapses = nnz(s_plasticityM);
t_nrOfCorrelationsPerSecond = sum(nnz(s_plasticityM))*t_stepsPerSecond;


% Launching --------------------------------------------------------------%
if t_visual == 1
    t_f2 = figure('Position',[0 900 700 900]);
    
    t_pauseButton = uicontrol(t_f2, 'Style', 'pushbutton',...
        'String', 'Pause',...
        'Position', [0 0 100 30],...
        'Callback', 'pause');
    
    t_suspendButton = uicontrol(t_f2, 'Style', 'pushbutton',...
        'String', 'Suspend',...
        'Position', [100 0 100 30],...
        'Callback', 'suspendExecution');
    t_resumedButton = uicontrol(t_f2, 'Style', 'pushbutton',...
        'String', 'Resume',...
        'Position', [200 0 100 30],...
        'Callback', 'resume');
    
    t_subplot1 = subplot(3,1,1,'Parent',t_f2);
    t_subplot2 = subplot(3,1,2,'Parent',t_f2);
    t_subplot3 = subplot(3,1,3,'Parent',t_f2);
end

runE2;

% Plotting results -------------------------------------------------------%
if t_suspendExecutionVar == 0    
    
    filename = ['e2r'  num2str(p_revision)  'seed' num2str(p_seedNumber) '_' num2str(p_samplingTime*1000) 'ms'...
        'time' num2str(s_time) 'trace' num2str(p_traceTC)...
                'maxDelay' num2str(p_maxTimeToReward) 'rc' num2str(p_HCPerSecond) '.mat'];
    save(filename);
    %plotE2r;
    s_cputime
else
  %  save matlabtemp;
end
