if exist('executingSet','var') == 0
    clear;
    disp('Instrumental Conditioning');
    
    p_simTime                = 3000;
    p_samplingTime           = 0.1;    
end

p_traceTC                = 1;

p_minTimeToReward        = 0;
p_maxTimeToReward        = 1;

p_timeBetweenStimuli     = 10;
p_stimuliStrength        = 20;
p_HCPerSecond            = 0.01;

p_neuronsInSetS           = 50;
p_neuronsInSetAB          = 50;

t_policy                = 0;

addpath common; 
addpath exp3;

userChoicesE3;

init;

p_sampleThresholdEstimationInSec            = 5;

createSABsets;

%keyboard;

if t_policy == 0
    t_flag = 0;
else
    t_flag = 1;
end


%Plasticity (this must be done after specific experiment settings)
s_plasticityM           = s_connectivity;
s_plasticityM(p_nr_excitatory + 1:p_nr_neurons,:) = 0;

t_numberOfSynapses      = nnz(s_connectivity);
t_numberOfPlasticSynapses = nnz(s_plasticityM);
t_nrOfCorrelationsPerSecond = sum(nnz(s_plasticityM))*t_stepsPerSecond;

% Derived parameters, logs and control variables -------------------------%
s_neuronsSEx = s_neuronsS(find(s_neuronsS < p_nr_excitatory + 1));
s_neuronsSIn = s_neuronsS(find(s_neuronsS > p_nr_excitatory));

s_minStepsToReward = round(p_minTimeToReward / p_samplingTime);
s_maxStepsToReward = round(p_maxTimeToReward / p_samplingTime);

s_activeANeurons = 0;
s_activeBNeurons = 0;

s_giveReward        = 0;
s_givePunishment    = 0;
s_trial             = 1;

l_StoA            = zeros(1,s_totSteps);
l_StoB            = zeros(1,s_totSteps);
l_AtoA            = zeros(1,s_totSteps);
l_BtoB            = zeros(1,s_totSteps);

l_StoNet          = zeros(1,s_totSteps);
l_allNet          = zeros(1,s_totSteps);
l_output          = zeros(s_totSteps, p_nr_neurons);
l_outA            = zeros(1,s_totSteps);
l_outB            = zeros(1,s_totSteps);
l_SABDiff         = zeros(1,s_totSteps);
l_probA           = 0.5 * ones(1,s_totSteps);
l_probB           = 0.5 * ones(1,s_totSteps);
l_rewards         = zeros(1,p_simTime/p_timeBetweenStimuli);
l_outDiff         = zeros(1,round(p_simTime/p_timeBetweenStimuli));
l_responseA       = zeros(1,p_simTime/p_timeBetweenStimuli);
l_responseB       = zeros(1,p_simTime/p_timeBetweenStimuli);

t_showOnceMore          = 0;
t_expNr                 = 3;
t_startAtStep           = 4;


% Launching --------------------------------------------------------------%
    t_f3 = figure('Position',[0 900 1200 900]);
    
    t_pauseButton = uicontrol(t_f3, 'Style', 'pushbutton',...
        'String', 'Pause',...
        'Position', [0 0 100 30],...
        'Callback', 'pause');
    
    t_suspendButton = uicontrol(t_f3, 'Style', 'pushbutton',...
        'String', 'Suspend',...
        'Position', [100 0 100 30],...
        'Callback', 'suspendExecution');
    t_resumedButton = uicontrol(t_f3, 'Style', 'pushbutton',...
        'String', 'Resume',...
        'Position', [200 0 100 30],...
        'Callback', 'resume');
%    h = uibuttongroup('visible','off','Position',[0 0 0.1 0.1]);
%    hu1 = uicontrol('Style','Radio','String','Policy 1',...
%    'pos',[450 30 120 30],'parent',h,'HandleVisibility','off');
%    hu2 = uicontrol('Style','Radio','String','Policy 2',...
%    'pos',[450 10 120 30],'parent',h,'HandleVisibility','off');
%set(h,'SelectedObject',[]);  % No selection
%set(h,'Visible','on');
%if t_policy == 0
%    set(hu1, 'Value',1);
%    set(hu2, 'Value',0);
%else
%    set(hu2, 'Value',1);
%    set(hu1, 'Value',0);
%end
    
        
    t_subplot1 = subplot(4,1,1,'Parent',t_f3);
    t_subplot2 = subplot(4,1,2,'Parent',t_f3);
    t_subplot3 = subplot(4,1,3,'Parent',t_f3);
    t_subplot4 = subplot(4,1,4,'Parent',t_f3);

    runE3;

% Plotting results -------------------------------------------------------%

if t_suspendExecutionVar == 0
    
    filename = ['e3r'  num2str(p_revision)...
        'seed' num2str(s_currentSeed)...
        'Pol' num2str(t_policy)...
        'int' num2str(p_samplingTime*1000) 'ms'...
        'time' num2str(s_time)...
        'trace' num2str(p_traceTC)...
        'LTt' num2str(p_decayLT) 's'...
        'maxDelay' num2str(p_maxTimeToReward)...
        'rc' num2str(p_HCPerSecond)...
        'noise' num2str(p_transmissionNoise) '.mat'];
   
    save(filename);

    plotE3r;
    s_cputime
else
   % save matlabTemp;
end


