% Variable prefixes:
% p_ : parameter of the experiment
% s_ : simulation variable
% t_ : temporary support variable
% l_ : log variable

disp('Testing Network');
tic
p_simTime                = 5200;
p_samplingTime           = 0.025;
p_modCorrectiveFactor    = 0.1 * p_samplingTime;
p_traceTC                = 1;
p_longTermTC             = 1000000;
p_minTimeToReward        = 0;
p_maxTimeToReward        = 1;
p_minTimeBetweenStimuli  = 0.1;
p_maxTimeBetweenStimuli  = 0.3;

p_baseMod                = (0.001*p_samplingTime)...
                             + (0.001 * p_samplingTime * p_modCorrectiveFactor);
p_maxModulation             = 0.1 + (0.1 * p_modCorrectiveFactor); 
p_activationFactor       = 0.15;
p_stimuliStrength        = 1;
p_nr_sets                = 100;
p_estimationTime         = 60;

s_minStepsToReward       = round(p_minTimeToReward / p_samplingTime );
s_maxStepsToReward       = round(p_maxTimeToReward / p_samplingTime );

p_posHCPercentPerSec = 0.01;
p_posHCPercentPerStep = p_posHCPercentPerSec * p_samplingTime;

p_negHCPercentPerSec = 0.02;
p_negHCPercentPerStep = p_negHCPercentPerSec * p_samplingTime;

p_positiveCorrThreshold = 1;
p_negativeCorrThreshold = -1;

addpath exp2;

userChoicesE2;

addpath common; 

init;

if exist('s_connectivity','var') == 0 || ...
    exist('s_neuronTypes','var') == 0

disp('Missing simulation variables, cannot simulate');

else
    
   
s_stepsToStimulus = myrandi(stream, 1, 1, round(p_minTimeBetweenStimuli / p_samplingTime)+1, round(p_maxTimeBetweenStimuli / p_samplingTime)+1);
t_currentStimulus       = 0;

l_output                = zeros(s_totSteps, p_nr_neurons);

% Launching --------------------------------------------------------------%

    serviceVariablesCommon;
    exp2;

% Plotting results -------------------------------------------------------%

end
