    t_f1 = figure('Position',[0 0 1200 800]);
    
    t_pauseButton = uicontrol(t_f1, 'Style', 'pushbutton',...
        'String', 'Pause',...
        'Position', [0 0 100 30],...
        'Callback', 'pause');
    
    t_suspendButton = uicontrol(t_f1, 'Style', 'pushbutton',...
        'String', 'Suspend',...
        'Position', [100 0 100 30],...
        'Callback', 'suspendExecution');
    t_resumedButton = uicontrol(t_f1, 'Style', 'pushbutton',...
        'String', 'Resume',...
        'Position', [200 0 100 30],...
        'Callback', 'resume');

    t_f1_sp1 = subplot(4,2,1,'Parent',t_f1);        
    t_f1_sp1_plot = plot(l_oneWeight(1:s_step-1),'Parent',t_f1_sp1);
    set(t_f1_sp1_plot,'YDataSource','l_oneWeight(1:s_step-1)');
    grid;
    if p_elig == 1
    ylabel(t_f1_sp1,'Weight of \sigma');
    else
    ylabel(t_f1_sp1,'Weight of \newline long-term \sigma');
    end
    
    t_f1_sp2 = subplot(4,2,2,'Parent',t_f1);
    t_f1_sp2_plot =  plot(l_modulation(1:s_step-1),'Parent',t_f1_sp2);
    set(t_f1_sp2_plot,'YDataSource','l_modulation(1:s_step-1)');
    grid;
    ylabel(t_f1_sp2,'Modulation');
 
    t_f1_sp3 = subplot(4,2,3,'Parent',t_f1);
    bins = zeros(1,101);
    t_f1_sp3_plot =  bar(bins,'Parent',t_f1_sp3);
    set(t_f1_sp3_plot,'YDataSource','bins');
    grid;
    ylabel(t_f1_sp3,'Long-term \newline Weight Hist');
    set(t_f1_sp3,'YLim',[0 6]);
    set(t_f1_sp3,'XLim',[0 105]);

       
    t_f1_sp4 = subplot(4,2,4,'Parent',t_f1);
    t_f1_sp4_plot = plot(l_rareEventsRate(1:s_step-1), 'Parent', t_f1_sp4);
    set(t_f1_sp4_plot,'YDataSource','l_rareEventsRate(1:s_step-1)');
    ylabel(t_f1_sp4,'Corr %');
    grid;
   

    t_f1_sp5 = subplot(4,2,5,'Parent',t_f1);
    t_f1_sp5_plot = plot(l_posThreshold, 'Parent', t_f1_sp5);
    set(t_f1_sp5_plot,'YDataSource','l_posThreshold');
    ylabel(t_f1_sp5,'Threshold');
    grid;
    axis([1 min(3,s_step) (-0.0001 + 1.2 * min(l_negThreshold(1/p_samplingTime+1:s_totSteps))) (0.0001 + 1.2 * max(l_posThreshold(1/p_samplingTime+1:s_totSteps)))]);

    t_f1_sp6 = subplot(4,2,6,'Parent',t_f1);   
    t_f1_sp6_plot = plot(l_output(1:s_step-1), 'Parent', t_f1_sp6);
    set(t_f1_sp6_plot,'YDataSource','l_output(1:s_step-1)');
    grid;
    ylabel(t_f1_sp6,'Network activity');
    set(t_f1_sp6,'YLim',[-10,150]);
    
    t_f1_sp7 = subplot(4,2,7,'Parent',t_f1);
    t_f1_sp7_plot = plot(l_corrPerStep(1:s_step-1,1), 'Parent', t_f1_sp7);
    set(t_f1_sp7_plot,'YDataSource','l_corrPerStep(1:s_step-1,1)');
    ylabel(t_f1_sp7,'Number Corr Per Step');
    grid;
    
