disp(['(Re)starting simulation E1']);

for s_step = t_startAtStep:1:s_totSteps
    
    s_time = s_step * p_samplingTime;
    
    
    % performs basic neural computation and computes correlations
    neuralComputation;
    % this script adjusts the thresholds for detecting rare correlations
    rarityOfCorrelations;
    % if a correlation between A and B is detected, set a countdown to
    % reward
    % update the traces according to the detected correlations.  This part
    % is the last because it assumes that traces take one step to increase,
    % after correlations occur.
    updateTraces;

    assignRewardE1;
    % update weights
    plasticity;
    
    %if s_step == s_stimulusAtStep + 2
    %    disp([num2str(s_step) ': ' num2str(s_highCorr(s_neuronA,s_neuronB))]);
    %    if s_highCorr(s_neuronA,s_neuronB) == 0.5
    %        s_inducedCorr(s_step) = 1;
    %        disp('');
    %        disp('Detected correlation');
    %    end
    %end
    
    tic
    % Logging variables
    logE1;
    
    % plotting results real time
    if t_executingSet == 0
        % Runtime output
        if mod(s_step * p_samplingTime,10) < 0.25 % || s_stepsToReward >= -1%|| s_highCorr(s_neuronA,s_neuronB) == 1 || t_showOnceMore == 1 || s_stepsToReward == -1
            
            %            t_stPosHebbTotal = sum(sum( (s_shortTermHebb > 0) .* s_shortTermHebb));
            %            t_stNegHebbTotal = sum(sum( (s_shortTermHebb < 0) .* s_shortTermHebb));
            
            disp(['T: ' num2str(s_time,'%.2f') ' S: ' num2str(s_step)...
                ' sigmaW:' num2str(s_weightM(s_neuronA,s_neuronB),'%.5f')...
                ' sigmaC:' num2str(s_shortTermHebb(s_neuronA,s_neuronB),'%.4f')...
                ' +HC/st:' num2str(s_numberOfPosHighCorrPerStep,'%04d')...
                ' -HC/st:' num2str(s_numberOfNegHighCorrPerStep,'%04d')...
                ' +Th:' num2str(p_positiveCorrThreshold,'%.4f')...
                ' -Th:' num2str(p_negativeCorrThreshold,'%.4f')...
                ' UpdtTh: ' num2str(t_updateThreshold)...
                ' +HC%/s: ' num2str(l_rareEventsRate(s_step))...
                ]);
            
            if s_highCorr(s_neuronA,s_neuronB) > 0
                t_showOnceMore = 1;
            else
                t_showOnceMore = 0;
            end
            
            refreshGraphsE1;
            
            if p_printing == 1
                           set(t_f1, 'PaperPositionMode', 'auto');
                figureFileName = ['./png/e1r' num2str(p_revision) '_' num2str(p_samplingTime) 'ms_seed' num2str(p_seedNumber)...
                    'time' num2str(s_time) 'trace' num2str(p_traceTC)...
                    'maxDelay' num2str(p_maxTimeToReward) '.png'];
                %print2eps(figureFileName, t_f1);
                
                %printOption = '-depsc2'; % for eps
                printOption = '-dpng'; % for png
                
                print(t_f1, printOption, figureFileName);
            end
        end
    end
    
    if t_suspendExecutionVar == 1
        break;
    end
    s_cputime(5) = s_cputime(5) + toc;
end
