disp(['Starting simulation']);

for s_step = t_startAtStep:1:s_totSteps
    s_time = s_step * p_samplingTime;
    
    % neurons in group S are highly active every 10 seconds
    stimuli_IC;
    
    neuralComputation;
    
    rarityOfCorrelations;
    
    updateTraces;
    
    checkResponse;
    
    s_totalModulation = p_baseMod;
    if s_stepsToReward == 0;
        disp(['Delayed reward at step: ' num2str(s_step)]);
        s_totalModulation = p_maxModulation;
    end
    
    if s_stepsToPunishment == 0;
        disp(['Delayed punishment at step: ' num2str(s_step)]);
        s_totalModulation = p_baseMod;
%       s_totalModulation = -p_maxModulation;
    end
    
    plasticity;
   
    s_stepsToReward     = s_stepsToReward - 1;
    s_stepsToPunishment = s_stepsToPunishment - 1;
    
    tic
    
    takeLogs;
 
    
    if s_step > 3 && mod(s_time,p_timeBetweenStimuli) < 2 * p_samplingTime || s_stepsToReward >= -1
        
        t_nrOfHC = nnz(s_highCorr);
        t_posHT = nnz(s_highCorr > 0);
        t_posHTHTratio = t_posHT / t_nrOfHC;
        
        disp(['T:' num2str(s_step*p_samplingTime) ' S:' num2str(s_step)...
            ' A' num2str(sum(s_activeANeurons)) ' B' num2str(sum(s_activeBNeurons))...
            ' SA' num2str(l_StoA(s_step)) ' SB' num2str(l_StoB(s_step))...
            ' HC:' num2str(t_nrOfHC)...
            ' SApnC' num2str(l_SApC(s_step)) '/' num2str(l_SAnC(s_step))...
            ' SBpnC' num2str(l_SBpC(s_step)) '/' num2str(l_SBnC(s_step))...
            ' stSA' num2str(sum(sum(s_shortTermHebb(s_neuronsS,s_neuronsA))))...
            ' stSB' num2str(sum(sum(s_shortTermHebb(s_neuronsS,s_neuronsB))))...
            ' +HC/HC: ' num2str(t_posHTHTratio)...
            ' +HCTh:' num2str(p_positiveCorrThreshold)...
            ' +HCPercent/sec: ' num2str(l_rareEventsRate(s_step))...
            
            ]);
        
        plotE3r;
        
    end      
    
    if t_suspendExecutionVar == 1
        break;
    end
    s_cputime(5) = s_cputime(5) + toc;    
end
