clear;

disp('Executing statistical set of experiment E1 with different random seeds');
t_executingSet = 1;

p_nr_RUNS                       = 40;
p_seedNumber                    = 1111;

p_simTime                       = 5400;
p_samplingTime                  = 1;
p_traceTC                       = 2;
p_minTimeToReward               = 1;
p_maxTimeToReward               = 3;
p_inhibWeightRange              = 1;
p_HCPerSecond                   = 0.01;
p_minIntervalBetweenRewards     = 2 * p_maxTimeToReward;

%stream = RandStream('mrg32k3a', 'Seed', p_seedNumber);

addpath exp1;
addpath common;

userChoicesE1;

init;

% Logs for the whole set
l_topSynapses           = zeros(p_nr_RUNS,100);
l_allRunsTopWeight      = zeros(p_nr_RUNS, s_totSteps);
l_allRunsMod            = zeros(p_nr_RUNS, s_totSteps);

s_runNr = 1;

for s_seedn = p_seedNumber:(p_seedNumber + p_nr_RUNS - 1)
   disp(['Executing run with seed ' num2str(s_seedn)])
   stream = RandStream('mrg32k3a', 'Seed', s_seedn);

   e1Synapse;
   
   t_topSynapses = sort(max(s_weightM));
   l_allRunsTopWeight(s_runNr,:) = l_oneWeight;
   l_allRunsMod(s_runNr,:) = l_modulation;
   
   l_topSynapses(s_runNr,:) = t_topSynapses(p_nr_neurons-99:p_nr_neurons);
   
   refreshGraphsE1;
   figureFileName = ['e1r'  num2str(p_revision)...
        'FigSeed' num2str(s_seedn)...
        'int' num2str(p_samplingTime*1000) 'ms'...
        'time' num2str(s_time)...
        'trace' num2str(p_traceTC)...
        'LTt' num2str(p_decayLT) 's'...
        'maxDelay' num2str(p_maxTimeToReward)...
        'rc' num2str(p_HCPerSecond)...
        'noise' num2str(p_transmissionNoise) '.eps'];
   
   printOption = '-depsc2'; % for eps
   %printOption = '-dpng'; % for png
   set(t_f1, 'PaperPositionMode', 'auto');
   print(t_f1, printOption, figureFileName);

   pause(1);
   close all;
   s_runNr = s_runNr + 1;
end